plan processMsg( msg )
{
	match msg with {
		"cnet", @{id}, @{task} -> {
			if( can_perform?( task ) ) {
				belief fact new {cnet_id = id, my_proposal = eval(task), t = task };
			} else belief fact new {cnet_id = id, my_proposal = INFINITY };
		}
	|
		"cnet-result", @{id}, @{result} -> {
			if( result == "won" ) {
				task_result = perform( belief query {cnet_id, my_proposal, t} as cn where cn.id == id );
				if( success ) comm.Send( msg.Src, "cnet-result " + id + " " + task_result );
				else comm.Send( msg.Src, "cnet-result " + id + " failure" );
			}
		}
	}
}


------------------

plan cnet( task )
{
	comm.Bcast( "cnet " + id + " " + task );
	winner_id = comm.Reduce( MIN_ID, @{(belief query {cnet_id, my_proposal} as p)[0].my_proposal } );
	comm.Send( winner_id, "cnet-result " + id + " won" );
	task_result = comm.Recv( winner_id );
}
