plan processMsg( msg )
{
	expr = "";
	id = -1;
	match msg with {
		"query-if", @{id}, @{expr} -> {
			qType = Q_IF;
		}
	|	"query-ref", @{id}, @{expr} -> {
			qType = Q_REF;
		}
	}
	if( is_public( expr ) ) {
		comm.Send( msg.Src, "query-res " + id + " permission agreed" );
		retVal = eval_expr( expr ) ;
		if( qType == Q_IF ) {
			comm.Send( msg.Src, "query-res " + id + " inform-t/f " + retVal );
		} else comm.Send( msg.Src, "query-res " + id + " inform-result " + retVal );
	} else {
		comm.Send( msg.Src, "query-res " + id + " permission refused" );
	}
}


plan query( target, expr, type )
{
	if( type == Q_IF ) msg = "query-if " + id + " " + expr;
	else msg = "query-ref " + id + " " + expr;
	comm.Send( target, msg );
	ret = comm.Recv( target );
	match ret with {
		"query-res", @{id}, "permission", @{perm}
	}
	if( perm == "refused" ) Console.WriteLine( "refused" );
	else {
		ret = comm.Recv( target );
	}
}
