plan processMsg( msg )
{
	match msg with
	{
		"request-when", @{id}, @{action}, @{cond} -> {
			if( can_perform?( action ) ) {
				comm.Send( msg.Src, "request-when " + id + " agreed" );
				while( 1 ) if( eval( cond ) ) break;
				result = perform( action );
				if( success ) comm.Send( "request-when-result " + id + " " + result );
				else comm.Send( "request-when-result " + id + " failure" );
			} else {
				comm.Send( msg.Src, "request-when " + id + " refused" );
			}
		}
	}
}

---------------------

plan processMsg( msg )
{
	match msg with {
		"request-when-result", @{id}, @{result} -> {
			if( belief query {request_when_id} as r where (r.request_when_id == id ) ) {
				if( result == "failure" ) belief fact new {request_when_result = id, FAIL};
				else belief fact new {request_when_result = id, result};
				belief remove {request_when_id} as r where (r.request_when_id == id);
			}
		}
	}
}

plan request( target, action, cond )
{
	comm.Send( target, "request-when " + id + " " + action + " " + cond );
	ret = comm.Recv( target );
	match ret with {
		"request-when", id, "agreed" -> belief fact new {request_when_id = id};
	|	"request-when", id, "refused" -> Console.WriteLine( "refused" );
	}
}
