plan subscribe()
{
	comm.Send( target, "subscribe " + id + " " + expr );
	retMsg = comm.Recv( target );
	if( agreed?( retMsg ) ) 
		belief fact new {subscribe_id = id, result = null};
}

plan processMsg( msg )
{
	match msg with {
		"subscribe", @{id}, @{result} -> {
			sObj = belief query {subscribe_id, result} as s where s.subscribe_id == id;
			if( sObj ) sObj.result = result;
		}
	}
}

---------------

plan processMsg( msg )
{
	match msg with {
		"subscribe", @{id}, @{expr} -> {
			if( permitted?( expr ) ) {
				comm.Send( msg.Src, "subscribe-response " + id + " agreed" );
				obj = get_reference( expr );
				comm.Send( msg.Src, "subscribe-result " + id + " " + obj );
				while( 1 ) {
					if( obj.WaitForChangeEvent() ) comm.Send( msg.Src, "subscribe-result " + id + " " + obj );
				}
			} else comm.Send( msg.Src, "subscribe-response " + id + " refused" );
		}
	}
}

plan main()
{
	change obj;
	obj.SetChangeEvent();
}
