plan propose()
{
	comm.Send( target, "fipa-propose " + id + " " + task );
	retMsg = comm.Recv( target );
	math retMsg with {
		"fipa-propose-response", id, "accepted" -> {
			result = perform( task );
			comm.Send( target, "fipa-propose-result " + id + " " + result );
		}
	}
}

------------
plan processMsg( msg )
{
	match msg with {
		"fipa-propose", @{id}, @{task} -> {
			if( accept( task ) ) {
				comm.Send( msg.Src, "fipa-propose-response " + id + " accepted" );
				result = comm.Recv( msg.Src );
			} else comm.Send( msg.Src, "fipa-propose-response " + id + " rejected" );
		}
	}
}
