plan processMsg( msg )
{
	match msg with {
		"requestip", id, @{action} -> {
			is_agreed = can_perform?( action );
			if( is_agreed ) {
				comm.Send( msg.Src, "requestip " + id + " agreed" );
				result = perform( action );
				comm.Send( msg.Src, "requestip " + id + " " + result );
			} else comm.Send( msg.Src, "requestip " + id + " refused" );
		}
	}
}

plan request(target, action)
{
	comm.Send( target, "requestip " + id + " " + action );
	msg = comm.Recv( target );
	match msg with {
		"requestip", id, "agreed" -> result = comm.Recv( target );
	|	"requestip", id, "refused" -> Console.WriteLine( "Refused" );
	}
}

